-- periodic player state update

local state_ready = false

AddEventHandler("playerSpawned",function() -- delay state recording
  state_ready = false
  
	Citizen.CreateThread(function()
		Citizen.Wait(30000)
		state_ready = true
	end)  
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(900000)
		vRPserver.updateHoursPlayed({0.25})
	end
end)

Citizen.CreateThread(function()
  while true do
    Citizen.Wait(30000)

    if IsPlayerPlaying(PlayerId()) and state_ready then
      local x,y,z = table.unpack(GetEntityCoords(PlayerPedId(),true))
      vRPserver.updatePos({x,y,z})
      vRPserver.updateHealth({tvRP.getHealth()})
   --   vRPserver.updateArmura({tvRP.getArmura()})
      vRPserver.updateWeapons({tvRP.getWeapons()})
      vRPserver.updateCustomization({tvRP.getCustomization()})
    end
  end
end)

-- WEAPONS

-- def
local allWeapons = {
  "WEAPON_DAGGER",
  "WEAPON_BAT",
  "WEAPON_BOTTLE",
  "WEAPON_CROWBAR",
  "WEAPON_FLASHLIGHT",
  "WEAPON_GOLFCLUB",
  "WEAPON_HAMMER",
  "WEAPON_HATCHET",
  "WEAPON_KNUCKLE",
  "WEAPON_KNIFE",
  "WEAPON_MACHETE",
  "WEAPON_SWITCHBLADE",
  "WEAPON_NIGHTSTICK",
  "WEAPON_WRENCH",
  "WEAPON_BATTLEAXE",
  "WEAPON_POOLCUE",
  "WEAPON_STONE_HATCHET",
  "WEAPON_PISTOL",
  "WEAPON_PISTOL_MK2",
  "WEAPON_COMBATPISTOL",
  "WEAPON_APPISTOL",
  "WEAPON_STUNGUN",
  "WEAPON_PISTOL50",
  "WEAPON_SNSPISTOL",
  "WEAPON_SNSPISTOL_MK2",
  "WEAPON_HEAVYPISTOL",
  "WEAPON_VINTAGEPISTOL",
  "WEAPON_FLAREGUN",
  "WEAPON_MARKSMANPISTOL",
  "WEAPON_REVOLVER",
  "WEAPON_REVOLVER_MK2",
  "WEAPON_DOUBLEACTION",
  "WEAPON_RAYPISTOL",
  "WEAPON_CERAMICPISTOL",
  "WEAPON_NAVYREVOLVER",
  "WEAPON_GADGETPISTOL",
  "WEAPON_MICROSMG",
  "WEAPON_SMG",
  "WEAPON_SMG_MK2",
  "WEAPON_ASSAULTSMG",
  "WEAPON_COMBATPDW",
  "WEAPON_MACHINEPISTOL",
  "WEAPON_MINISMG",
  "WEAPON_RAYCARBINE",
  "WEAPON_PUMPSHOTGUN",
  "WEAPON_PUMPSHOTGUN_MK2",
  "WEAPON_SAWNOFFSHOTGUN",
  "WEAPON_ASSAULTSHOTGUN",
  "WEAPON_BULLPUPSHOTGUN",
  "WEAPON_MUSKET",
  "WEAPON_HEAVYSHOTGUN",
  "WEAPON_DBSHOTGUN",
  "WEAPON_AUTOSHOTGUN",
  "WEAPON_COMBATSHOTGUN",
  "WEAPON_ASSAULTRIFLE",
  "WEAPON_ASSAULTRIFLE_MK2",
  "WEAPON_CARBINERIFLE",
  "WEAPON_CARBINERIFLE_MK2",
  "WEAPON_ADVANCEDRIFLE",
  "WEAPON_SPECIALCARBINE",
  "WEAPON_SPECIALCARBINE_MK2",
  "WEAPON_BULLPUPRIFLE",
  "WEAPON_BULLPUPRIFLE_MK2",
  "WEAPON_COMPACTRIFLE",
  "WEAPON_MILITARYRIFLE",
  "WEAPON_MG",
  "WEAPON_COMBATMG",
  "WEAPON_COMBATMG_MK2",
  "WEAPON_GUSENBERG",
  "WEAPON_SNIPERRIFLE",
  "WEAPON_HEAVYSNIPER",
  "WEAPON_HEAVYSNIPER_MK2",
  "WEAPON_MARKSMANRIFLE",
  "WEAPON_MARKSMANRIFLE_MK2",
  "WEAPON_RPG",
  "WEAPON_GRENADELAUNCHER",
  "WEAPON_GRENADELAUNCHER_SMOKE",
  "WEAPON_MINIGUN",
  "WEAPON_FIREWORK",
  "WEAPON_RAILGUN",
  "WEAPON_HOMINGLAUNCHER",
  "WEAPON_COMPACTLAUNCHER",
  "WEAPON_RAYMINIGUN",
  "WEAPON_GRENADE",
  "WEAPON_BZGAS",
  "WEAPON_MOLOTOV",
  "WEAPON_STICKYBOMB",
  "WEAPON_PROXMINE",
  "WEAPON_SNOWBALL",
  "WEAPON_PIPEBOMB",
  "WEAPON_BALL",
  "WEAPON_SMOKEGRENADE",
  "WEAPON_FLARE",
  "WEAPON_PETROLCAN",
  "GADGET_PARACHUTE",
  "WEAPON_FIREEXTINGUISHER",
  "WEAPON_HAZARDCAN"
}

local weapon_types = {
  {"WEAPON_KNIFE"},
  {"WEAPON_KNUCKLE","","",""},
  {"WEAPON_STUNGUN"},
  {"WEAPON_NIGHTSTICK"},
  {"WEAPON_HAMMER"},
  {"WEAPON_BAT"},
  {"WEAPON_GOLFCLUB"},
  {"WEAPON_CROWBAR"},
  {"WEAPON_BOTTLE"},
  {"WEAPON_DAGGER"},
  {'WEAPON_GADGETPISTOL'},
  {'WEAPON_NAVYREVOLVER'},
  {'WEAPON_DOUBLEACTION'},
  {"WEAPON_MACHETE"},
  {"WEAPON_FIREWORK"},
  {"WEAPON_FLASHLIGHT"},
  {"WEAPON_SWITCHBLADE","","","COMPONENT_SWITCHBLADE_VARMOD_VAR1"},
  {"WEAPON_PISTOL","COMPONENT_AT_PI_SUPP_02","COMPONENT_AT_PI_FLSH","COMPONENT_PISTOL_VARMOD_LUXE"},
  {"WEAPON_COMBATPISTOL","COMPONENT_AT_PI_SUPP","COMPONENT_AT_PI_FLSH","COMPONENT_COMBATPISTOL_VARMOD_LOWRIDER"},
  {"WEAPON_APPISTOL","COMPONENT_AT_PI_SUPP","COMPONENT_AT_PI_FLSH","COMPONENT_APPISTOL_VARMOD_LUXE"},
  {"WEAPON_PISTOL50","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_PI_FLSH","COMPONENT_PISTOL50_VARMOD_LUXE"},
  {"WEAPON_MICROSMG","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_PI_FLSH","COMPONENT_MICROSMG_VARMOD_LUXE","","COMPONENT_AT_SCOPE_MACRO"},
  {"WEAPON_SMG","COMPONENT_AT_PI_SUPP","COMPONENT_AT_AR_FLSH","COMPONENT_SMG_VARMOD_LUXE","","COMPONENT_AT_SCOPE_MACRO_02"},
  {"WEAPON_ASSAULTSMG","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_AR_FLSH","COMPONENT_ASSAULTSMG_VARMOD_LOWRIDER","","COMPONENT_AT_SCOPE_MACRO"},
  {"WEAPON_ASSAULTRIFLE","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_AR_FLSH","COMPONENT_ASSAULTRIFLE_VARMOD_LUXE","COMPONENT_AT_AR_AFGRIP","COMPONENT_AT_SCOPE_MACRO"},
  {"WEAPON_SPECIALCARBINE","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_AR_FLSH","COMPONENT_SPECIALCARBINE_VARMOD_LOWRIDER","COMPONENT_AT_AR_AFGRIP","COMPONENT_AT_SCOPE_MEDIUM"},
  {"WEAPON_CARBINERIFLE","COMPONENT_AT_AR_SUPP","COMPONENT_AT_AR_FLSH","COMPONENT_CARBINERIFLE_VARMOD_LUXE","COMPONENT_AT_AR_AFGRIP","COMPONENT_AT_SCOPE_MEDIUM"},
  {"WEAPON_ADVANCEDRIFLE","COMPONENT_AT_AR_SUPP","COMPONENT_AT_AR_FLSH","COMPONENT_ADVANCEDRIFLE_VARMOD_LUXE","","COMPONENT_AT_SCOPE_SMALL"},
  {"WEAPON_MG","","","COMPONENT_MG_VARMOD_LOWRIDER","","COMPONENT_AT_SCOPE_SMALL_02"},
  {"WEAPON_COMBATMG","","","COMPONENT_COMBATMG_VARMOD_LOWRIDER","COMPONENT_AT_AR_AFGRIP","COMPONENT_AT_SCOPE_MEDIUM"},
  {"WEAPON_PUMPSHOTGUN","COMPONENT_AT_SR_SUPP","COMPONENT_AT_AR_FLSH","COMPONENT_PUMPSHOTGUN_VARMOD_LOWRIDER"},
  {"WEAPON_SAWNOFFSHOTGUN","","","COMPONENT_SAWNOFFSHOTGUN_VARMOD_LUXE"},
  {"WEAPON_ASSAULTSHOTGUN","COMPONENT_AT_AR_SUPP","COMPONENT_AT_AR_FLSH","","COMPONENT_AT_AR_AFGRIP"},
  {"WEAPON_HEAVYSHOTGUN","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_AR_FLSH","","COMPONENT_AT_AR_AFGRIP"},
  {"WEAPON_BULLPUPSHOTGUN","COMPONENT_AT_AR_SUPP_02","COMPONENT_AT_AR_FLSH","","COMPONENT_AT_AR_AFGRIP"},
  {"WEAPON_STUNGUN"},
  {"WEAPON_BULLPUPRIFLE"},
  {"WEAPON_MACHINEPISTOL"},
  {"WEAPON_REVOLVER_MK2"},
  {"WEAPON_SNIPERRIFLE","COMPONENT_AT_AR_SUPP_02","","COMPONENT_SNIPERRIFLE_VARMOD_LUXE","","COMPONENT_AT_SCOPE_MAX"},
  {"WEAPON_HEAVYSNIPER"},
  {"WEAPON_REMOTESNIPER"},
  {"WEAPON_GRENADELAUNCHER"},
  {"WEAPON_GRENADELAUNCHER_SMOKE"},
  {"WEAPON_RPG"},
  {"WEAPON_PASSENGER_ROCKET"},
  {"WEAPON_AIRSTRIKE_ROCKET"},
  {"WEAPON_STINGER"},
  {"WEAPON_MINIGUN"},
  {"WEAPON_GRENADE"},
  {"WEAPON_STICKYBOMB"},
  {"WEAPON_SMOKEGRENADE"},
  {"WEAPON_BZGAS"},
  {"WEAPON_MOLOTOV"},
  {"WEAPON_FIREEXTINGUISHER"},
  {"WEAPON_PETROLCAN"},
  {"WEAPON_DIGISCANNER"},
  {"WEAPON_BRIEFCASE"},
  {"WEAPON_BRIEFCASE_02"},
  {"WEAPON_BALL"},
  {"WEAPON_FLARE"}
}

function tvRP.getWeaponTypes()
  return weapon_types
end

function tvRP.getWeapons()
  local player = PlayerPedId()

  local ammo_types = {} -- remember ammo type to not duplicate ammo amount

  local weapons = {}
  for k,v in pairs(weapon_types) do
    local hash = GetHashKey(v[1])
    if HasPedGotWeapon(player,hash) then
      local weapon = {}
      weapons[v[1]] = weapon

      local atype = Citizen.InvokeNative(0x7FEAD38B326B9F74, player, hash)
      if ammo_types[atype] == nil then
        ammo_types[atype] = true
        weapon.ammo = GetAmmoInPedWeapon(player,hash)
      else
        weapon.ammo = 0
      end
      if v[2] ~= nil or v[2] ~= "" then
        if HasPedGotWeaponComponent(player,hash, GetHashKey(tostring(v[2]))) == 1 then
          weapon.supressor = tostring(v[2])
        else
          weapon.supressor = "nu"
        end
      end
      if v[3] ~= nil or v[3] ~= "" then
        if HasPedGotWeaponComponent(player,hash, GetHashKey(tostring(v[3]))) == 1 then
          weapon.flash = tostring(v[3])
        else
          weapon.flash = "nu"
        end
      end
      if v[4] ~= nil or v[4] ~= "" then
        if HasPedGotWeaponComponent(player,hash, GetHashKey(tostring(v[4]))) == 1 then
          weapon.yusuf = tostring(v[4])
        else
          weapon.yusuf = "nu"
        end
      end
      if v[5] ~= nil or v[5] ~= "" then
        if HasPedGotWeaponComponent(player,hash, GetHashKey(tostring(v[5]))) == 1 then
          weapon.grip = tostring(v[5])
        else
          weapon.grip = "nu"
        end
      end
      if v[6] ~= nil or v[6] ~= "" then
        if HasPedGotWeaponComponent(player,hash, GetHashKey(tostring(v[6]))) == 1 then
          weapon.scope = tostring(v[6])
        else
          weapon.scope = "nu"
        end
      end
    end
  end

  return weapons
end

local whs = {}

function tvRP.returnwhs()
  return whs
end


function tvRP.isWeaponInTable(wHash)
  if whs[wHash] then
    return true
  end
  return false
end

function tvRP.giveWeapons(weapons,clear_before)
  local player = PlayerPedId()

  if clear_before then
    whs = {}
    RemoveAllPedWeapons(player,true)
  end

  for k,weapon in pairs(weapons) do
    local hash = GetHashKey(k)
    local ammo = weapon.ammo or 0
    local supressor = weapon.supressor
    local flash = weapon.flash
    local yusuf = weapon.yusuf
    local grip = weapon.grip
    local scope = weapon.scope
    whs[hash] = true
    GiveWeaponToPed(player, hash, ammo, false)
    if supressor ~= "nu" and supressor ~= nil then
      GiveWeaponComponentToPed(PlayerPedId(), hash, GetHashKey(supressor))
    end
    if flash ~= "nu" and flash ~= nil then
      GiveWeaponComponentToPed(PlayerPedId(), hash, GetHashKey(flash))
    end
    if yusuf ~= "nu" and yusuf ~= nil then
      GiveWeaponComponentToPed(PlayerPedId(), hash, GetHashKey(yusuf))
    end
    if grip ~= "nu" and grip ~= nil then
      GiveWeaponComponentToPed(PlayerPedId(), hash, GetHashKey(grip))
    end
    if scope ~= "nu" and scope ~= nil then
      GiveWeaponComponentToPed(PlayerPedId(), hash, GetHashKey(scope))
    end
  end

  vRPserver.updateWeapons({tvRP.getWeapons()})
end


function tvRP.getWweapons()
  local player = PlayerPedId()
  local weapons = {}
  for k,v in pairs(weapon_types) do
    local hash = GetHashKey(v[1])
    if HasPedGotWeapon(player,hash) then
      return true
    end
  end
  return false
end

function tvRP.removeWeapons()
  RemoveAllPedWeapons(PlayerPedId(), false)
  myWeapons = {}
  vRPserver.updateWeapons({tvRP.getWeapons()})
end


--[[
function tvRP.dropWeapon()
  SetPedDropsWeapon(PlayerPedId())
end
--]]

-- PLAYER CUSTOMIZATION

-- parse part key (a ped part or a prop part)
-- return is_proppart, index

function filtern(t, cb) 
  local j = 1 
  for i, v in ipairs(t) do 
     if cb(v) then 
        t[j] = v 
        j = j + 1 
     end 
  end 
  while t[j] ~= nil do 
     t[j] = nil 
     j = j + 1 
  end 
  return t 
end

local onScreenEffects = {}

Citizen.CreateThread(function() 
   while not isTerminating do
       RequestStreamedTextureDict("MPHud")
       for i, e in pairs(onScreenEffects) do
           local sw, sh = GetScreenResolution()
           local w = 20.0
           local h = 23.0
           local sY = e.yFade
           
           SetDrawOrigin(e.x, e.y, e.z, 0)
           SetTextFont(0)
           SetTextColour(255, 255, 255, 200)
           SetTextScale(0.27, 0.27)
           SetTextEntry("STRING")
           SetTextColour(e.r,e.g,e.b,e.a)
           AddTextComponentString(e.text)
           DrawText(8 / sw, (-7.0 - sY) / sh)
           DrawSprite("MPHud", e.sprite, 0.0, -sY / sh, w / sw, h / sh, 0.0, 255, 255, 255, 180)
           ClearDrawOrigin()
           
           if e.fadeAfter <= 0 then 
               e.yFade = e.yFade * 1.25
           end
           e.ticks = e.ticks - 1
           e.fadeAfter = e.fadeAfter - 1
       end
       onScreenEffects = filtern(onScreenEffects, function(e) return e.ticks > 0 end)
       Wait(0)
   end
end)

function AddFloatingRpGained(x, y, z, text,r,g,b,a) 
   onScreenEffects[#onScreenEffects + 1] = {
       x = x + GetRandomFloatInRange(0.5, 0.6), 
       y = y + GetRandomFloatInRange(0.5, 0.6), 
       z = z + GetRandomFloatInRange(-0.2, 0),
       sprite = "mp_anim_cash",
       text = text,
       yFade = 1.0,
       r = r,
       g = g,
       b = b,
       a = a,
       fadeAfter = 130,
       ticks = 150
   }
end

function tvRP.arataTranzactie(tip,amount)
  pos = GetEntityCoords(PlayerPedId())
 
  if tip == "plus" then
    AddFloatingRpGained(pos.x, pos.y, pos.z, " +".. amount, 51, 204, 51, 150)
  else
    AddFloatingRpGained(pos.x, pos.y, pos.z, " -".. amount, 255, 0, 0, 255)
  end
 end
 
local function parse_part(key)
  if type(key) == "string" and string.sub(key,1,1) == "p" then
    return true,tonumber(string.sub(key,2))
  else
    return false,tonumber(key)
  end
end

function tvRP.getDrawables(part)
  local isprop, index = parse_part(part)
  if isprop then
    return GetNumberOfPedPropDrawableVariations(PlayerPedId(),index)
  else
    return GetNumberOfPedDrawableVariations(PlayerPedId(),index)
  end
end

function tvRP.getDrawableTextures(part,drawable)
  local isprop, index = parse_part(part)
  if isprop then
    return GetNumberOfPedPropTextureVariations(PlayerPedId(),index,drawable)
  else
    return GetNumberOfPedTextureVariations(PlayerPedId(),index,drawable)
  end
end

function tvRP.getCustomization()
  local ped = PlayerPedId()

  local custom = {}

  custom.modelhash = GetEntityModel(ped)

  -- ped parts
  for i=0,20 do -- index limit to 20
    custom[i] = {GetPedDrawableVariation(ped,i), GetPedTextureVariation(ped,i), GetPedPaletteVariation(ped,i)}
  end

  -- props
  for i=0,10 do -- index limit to 10
    custom["p"..i] = {GetPedPropIndex(ped,i), math.max(GetPedPropTextureIndex(ped,i),0)}
  end

  return custom
end

-- partial customization (only what is set is changed)
-- partial customization (only what is set is changed)
function tvRP.setCustomization(custom) -- indexed [drawable,texture,palette] components or props (p0...) plus .modelhash or .model
  local exit = TUNNEL_DELAYED() -- delay the return values

  Citizen.CreateThread(function() -- new thread
    if custom then
      local ped = PlayerPedId()
      local mhash = nil

      -- model
      if custom.modelhash ~= nil then
        mhash = custom.modelhash
      elseif custom.model ~= nil then
        mhash = GetHashKey(custom.model)
      end

      if mhash ~= nil then
        local i = 0
        while not HasModelLoaded(mhash) and i < 10000 do
          RequestModel(mhash)
          Citizen.Wait(10)
        end

        if HasModelLoaded(mhash) then
          -- changing player model remove weapons, so save it
          local weapons = tvRP.getWeapons()
          SetPlayerModel(PlayerId(), mhash)
          tvRP.giveWeapons(weapons,true)
          SetModelAsNoLongerNeeded(mhash)
        end
      end

      ped = PlayerPedId()

      -- parts
      for k,v in pairs(custom) do
        if k ~= "model" and k ~= "modelhash" then
          local isprop, index = parse_part(k)
          if isprop then
            if v[1] < 0 then
              ClearPedProp(ped,index)
            else
              SetPedPropIndex(ped,index,v[1],v[2],v[3] or 2)
            end
          else
            SetPedComponentVariation(ped,index,v[1],v[2],v[3] or 2)
          end
        end
      end
    end

    exit({})
  end)
end

RegisterNetEvent('trf:supp')
AddEventHandler('trf:supp', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_PISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PISTOL50") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL50"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_APPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_APPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_VINTAGEPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_VINTAGEPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PUMPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PUMPSHOTGUN"), GetHashKey("COMPONENT_AT_SR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SNIPERRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SNIPERRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MACHINEPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MACHINEPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MILITARYRIFLE") then 
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MILITARYRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  end
  TriggerEvent("adaugam_atasament", currentWeaponHash, "supressor")
end)

RegisterNetEvent('trf:flashlight')
AddEventHandler('trf:flashlight', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_PISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PISTOL50") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL50"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATPISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_APPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_APPISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYPISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PUMPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PUMPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MILITARYRIFLE") then 
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MILITARYRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  end
  TriggerEvent("adaugam_atasament", currentWeaponHash, "flash")
end)

RegisterNetEvent('trf:grip')
AddEventHandler('trf:grip', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPRIFLE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_AR_AFGRIP_02"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_AR_AFGRIP_02"))
  end
  TriggerEvent("adaugam_atasament", currentWeaponHash, "grip")
end)

RegisterNetEvent('trf:yusuf')
AddEventHandler('trf:yusuf', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_PISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL"), GetHashKey("COMPONENT_PISTOL_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PISTOL50") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL50"), GetHashKey("COMPONENT_PISTOL50_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_APPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_APPISTOL"), GetHashKey("COMPONENT_APPISTOL_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYPISTOL"), GetHashKey("COMPONENT_HEAVYPISTOL_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_SMG_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_MICROSMG_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_ASSAULTRIFLE_VARMOD_LUXE"))		
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_CARBINERIFLE_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_ADVANCEDRIFLE_VARMOD_LUXE"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SWITCHBLADE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SWITCHBLADE"), GetHashKey("COMPONENT_SWITCHBLADE_VARMOD_VAR1"))
  elseif currentWeaponHash == GetHashKey("WEAPON_KNUCKLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_KNUCKLE"), GetHashKey("COMPONENT_KNUCKLE_VARMOD_DIAMOND"))
  end
  vRPserver.updateWeapons({tvRP.getWeapons()})
end)

RegisterNetEvent('trf:scope')
AddEventHandler('trf:scope', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_AT_SCOPE_MACRO"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_AT_SCOPE_MACRO_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_AT_SCOPE_MACRO"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_SCOPE_MACRO"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_AT_SCOPE_SMALL"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MG"), GetHashKey("COMPONENT_AT_SCOPE_SMALL_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATMG"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSNIPER") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSNIPER"), GetHashKey("COMPONENT_AT_SCOPE_MAX"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM_MK2"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM_MK2"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MILITARYRIFLE") then 
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MILITARYRIFLE"), GetHashKey("COMPONENT_AT_SCOPE_SMALL"))
  end
  TriggerEvent("adaugam_atasament", currentWeaponHash, "scope")
end)

RegisterNetEvent('trf:magazine1')
AddEventHandler('trf:magazine1', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_PISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL"), GetHashKey("COMPONENT_PISTOL_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATPISTOL"), GetHashKey("COMPONENT_COMBATPISTOL_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_APPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_APPISTOL"), GetHashKey("COMPONENT_APPISTOL_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PISTOL50") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL50"), GetHashKey("COMPONENT_PISTOL50_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_MICROSMG_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_SMG_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_ASSAULTSMG_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_ASSAULTRIFLE_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_SPECIALCARBINE_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_CARBINERIFLE_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_ADVANCEDRIFLE_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MG"), GetHashKey("COMPONENT_MG_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATMG"), GetHashKey("COMPONENT_COMBATMG_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_ASSAULTSHOTGUN_CLIP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_HEAVYSHOTGUN_CLIP_02"))

  end
  vRPserver.updateWeapons({tvRP.getWeapons()})
end)




RegisterNetEvent('trf:scope:doarechipeaza')
AddEventHandler('trf:scope:doarechipeaza', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_AT_SCOPE_MACRO"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_AT_SCOPE_MACRO_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_AT_SCOPE_MACRO"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_SCOPE_MACRO"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_AT_SCOPE_SMALL"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MG"), GetHashKey("COMPONENT_AT_SCOPE_SMALL_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATMG"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSNIPER") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSNIPER"), GetHashKey("COMPONENT_AT_SCOPE_MAX"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM_MK2"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_SCOPE_MEDIUM_MK2"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MILITARYRIFLE") then 
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MILITARYRIFLE"), GetHashKey("COMPONENT_AT_SCOPE_SMALL"))
  end
end)

RegisterNetEvent('trf:grip:doarechipeaza')
AddEventHandler('trf:grip:doarechipeaza', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPRIFLE"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_AFGRIP"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_AR_AFGRIP_02"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_AR_AFGRIP_02"))
  end
end)

RegisterNetEvent('trf:flashlight:doarechipeaza')
AddEventHandler('trf:flashlight:doarechipeaza', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_PISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PISTOL50") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL50"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATPISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_APPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_APPISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYPISTOL"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_AT_PI_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PUMPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PUMPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MILITARYRIFLE") then 
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MILITARYRIFLE"), GetHashKey("COMPONENT_AT_AR_FLSH"))
  end
end)

RegisterNetEvent('trf:supp:doarechipeaza')
AddEventHandler('trf:supp:doarechipeaza', function()
  local ped = PlayerPedId()
  local currentWeaponHash = GetSelectedPedWeapon(ped)
  if currentWeaponHash == GetHashKey("WEAPON_PISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PISTOL50") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PISTOL50"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_COMBATPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_COMBATPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_APPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_APPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_VINTAGEPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_VINTAGEPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SMG"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MICROSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MICROSMG"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSMG") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSMG"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_CARBINERIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_CARBINERIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ADVANCEDRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ADVANCEDRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SPECIALCARBINE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SPECIALCARBINE"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_ASSAULTSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_ASSAULTSHOTGUN"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_HEAVYSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_HEAVYSHOTGUN"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_BULLPUPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_BULLPUPSHOTGUN"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("WEAPON_PUMPSHOTGUN") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_PUMPSHOTGUN"), GetHashKey("COMPONENT_AT_SR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_SNIPERRIFLE") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_SNIPERRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("weapon_assaultrifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_assaultrifle_mk2"), GetHashKey("COMPONENT_AT_AR_SUPP_02"))
  elseif currentWeaponHash == GetHashKey("weapon_carbinerifle_mk2") then
    GiveWeaponComponentToPed(ped, GetHashKey("weapon_carbinerifle_mk2"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MACHINEPISTOL") then
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MACHINEPISTOL"), GetHashKey("COMPONENT_AT_PI_SUPP"))
  elseif currentWeaponHash == GetHashKey("WEAPON_MILITARYRIFLE") then 
    GiveWeaponComponentToPed(ped, GetHashKey("WEAPON_MILITARYRIFLE"), GetHashKey("COMPONENT_AT_AR_SUPP"))
  end
end)